//*************************************************************************
//
//  Title:  tinyBillboard, by One Wolf WebArt
//  Author: cricci@diac.com (Christian Ricci)
//
//  For more information please refer to http://www.diac.com/~cricci
//
//*************************************************************************

import java.applet.*;
import java.awt.*;
import java.net.*;

public class tinyBB extends Applet
    implements Runnable {               // Threaded application
 
    int xpos=5,                         // X position
        ypos=0,                         // Y position
        maxMessages=1,                  // Number of messages/links
        current=1,                      // Current message being displayed
        fontOffset=12,                  // Estimate of font Height
        pause=500;                      // How long the current message stays
    String target$,
           ystop$;
    Image offImage;                     // Double buffering to eliminate
    Graphics offGrfx;                   // frame flicker
    Color background, fontColor, linkColor;
    boolean customFont = false,
            customLinkFont = false;
    Thread runner;

    int[] Height     = new int[100];
    String[] Message = new String[100];
    int[] delay      = new int[100];
    URL[] Link       = new URL[100];
    String[] target  = new String[100];

    Font outFont, linkFont;

    // URL Link = null;

    public void init() {
        int size;

        /****  Get attributes, if available  ****/
        String bgRed$      = getParameter("BGRED");
        String bgGreen$    = getParameter("BGGREEN");
        String bgBlue$     = getParameter("BGBLUE");
        String fgRed$      = getParameter("FGRED");
        String fgGreen$    = getParameter("FGGREEN");
        String fgBlue$     = getParameter("FGBLUE");
        String lnRed$      = getParameter("LNRED");
        String lnGreen$    = getParameter("LNGREEN");
        String lnBlue$     = getParameter("LNBLUE");
        String fontName$   = getParameter("FONTNAME");
        String fontSize$   = getParameter("FONTSIZE");
        String fontItalic$ = getParameter("FONTITALIC");
        String fontBold$   = getParameter("FONTBOLD");
        String lfontName$  = getParameter("LFONTNAME");
        String lfontSize$  = getParameter("LFONTSIZE");
        String lfontItalic$= getParameter("LFONTITALIC");
        String lfontBold$  = getParameter("LFONTBOLD");
        String xpos$       = getParameter("XPOS");
        String pause$      = getParameter("PAUSE");
               target$     = getParameter("TARGET");
               ystop$      = getParameter("YSTOP");

        /****          Load Lines           ****/
        maxMessages = 1;
        while ((Message[maxMessages] =
                getParameter("MESSAGE" + Integer.toString(maxMessages)))
                != null) { maxMessages++; }

        /****          Load Links           ****/
        for (int x=1; x<maxMessages; x++) {
            Link[x] = getURL(getParameter("LINK" + Integer.toString(x))); }

        /****          Load Target          ****/
        for (int x=1; x<maxMessages; x++) {
            target[x] = getParameter("TARGET" + Integer.toString(maxMessages)); }

        /****          Load Delay           ****/
        for (int x=1; x<maxMessages; x++) {
            String tmpStr = getParameter("DELAY" + Integer.toString(x));
            if (tmpStr != null) {
                delay[x] = Integer.parseInt(tmpStr);
            }
            else {
                delay[x] = 50;
            }
        }

        /****    Prep execute attributes    ****/
        if (xpos$ != null) 
          xpos = Integer.parseInt(xpos$);

        if (pause$ != null) 
          pause = Integer.parseInt(pause$);

        if ((fontSize$ != null) && (fontName$ != null)) {
            size = Integer.parseInt(fontSize$);
            fontOffset = size;
            int style = Font.PLAIN;
            if ((fontItalic$ != null) && (fontItalic$ != "0"))
                style = Font.ITALIC;
            if ((fontBold$ != null) && (fontBold$ != "0"))
                style += Font.BOLD;
            outFont = new Font(fontName$, style, size);
            customFont = true;
        }

        if ((lfontSize$ != null) && (lfontName$ != null)) {
            size = Integer.parseInt(lfontSize$);
            if (size > fontOffset) fontOffset = size;
            int style = Font.PLAIN;
            if ((lfontItalic$ != null) && (lfontItalic$ != "0"))
                style = Font.ITALIC;
            if ((lfontBold$ != null) && (lfontBold$ != "0"))
                style += Font.BOLD;
            linkFont = new Font(lfontName$, style, size);
            customLinkFont = true;
        }
        else linkFont = outFont;

        /****      Convert color values     ****/
        int Red=255;
        int Green=255; 
        int Blue=255;
        int fRed=0;
        int fGreen=0; 
        int fBlue=0;
        int lRed=255;
        int lGreen=255; 
        int lBlue=255;

        if (bgRed$ != null) Red = Integer.parseInt(bgRed$);
        if (bgGreen$ != null) Green = Integer.parseInt(bgGreen$);
        if (bgBlue$ != null) Blue = Integer.parseInt(bgBlue$);
        if (fgRed$ != null) fRed = Integer.parseInt(fgRed$);
        if (fgGreen$ != null) fGreen = Integer.parseInt(fgGreen$);
        if (fgBlue$ != null) fBlue = Integer.parseInt(fgBlue$);
        if (lnRed$ != null) lRed = Integer.parseInt(lnRed$);
        if (lnGreen$ != null) lGreen = Integer.parseInt(lnGreen$);
        if (lnBlue$ != null) lBlue = Integer.parseInt(lnBlue$);

        fontColor = new Color(fRed, fGreen, fBlue);
        linkColor = new Color(lRed, lGreen, lBlue);
        background = new Color(Red, Green, Blue);
        setBackground(background);

        offImage = createImage(size().width, size().height);
        offGrfx = offImage.getGraphics();

        ypos = size().height + fontOffset;
    }

    URL getURL(String urlText) {
        URL pageURL = null;
        try { pageURL = new URL(getDocumentBase(), urlText); }
        catch (MalformedURLException m) { }
        return pageURL;
    }

    public void paint(Graphics screen) {
          offGrfx.setColor(background);
          offGrfx.fillRect(0,0,size().width, size().height);

          if (Link[current] == null) {
              offGrfx.setColor(fontColor);
          }
          else {
              offGrfx.setColor(linkColor);
          }

          try {
              if (Link[current] != null) {
                  offGrfx.setFont(linkFont);
              }
              else {
                  offGrfx.setFont(outFont);
              }
          } catch (NullPointerException e) { }

          offGrfx.drawString(Message[current], xpos, ypos);
          screen.drawImage(offImage, 0, 0, this);
    }

    public void update(Graphics screen) {
          paint(screen); 
    }

    public void start() {
        if (runner == null) {
            runner = new Thread(this);
            runner.start();
        }
    }

    int getHeight(Font inFont, String inString) {
        FontMetrics fm;

        fm = getFontMetrics(inFont);
        return fm.getHeight();
    }

    public void run() {
        for (int x=1; x<maxMessages; x++) {
            if ((customFont) && (Link[x] == null))
                Height[x] = getHeight(outFont, Message[x]);
            else if ((customLinkFont) && (Link[x] != null))
                Height[x] = getHeight(linkFont, Message[x]);
            else Height[x] = fontOffset;
        }

        while(true) {
            repaint();
            ypos--;
            if (ypos <= 0) {
                ypos=size().height + fontOffset;
                 current ++;
                if (current == maxMessages) { current = 1; }
            }

            if (ypos == Ystop())
            {
                try { Thread.sleep(pause); }
                catch (InterruptedException e) { }
            }
  
            try { Thread.sleep(delay[current]); }
            catch (InterruptedException e) { }
         }
    }

    public int Ystop() {
        if (ystop$ != null) return Integer.parseInt(ystop$);
        else return (int)(((size().height)+Height[current]) / 2);
    }

    public void stop() {
        if (runner != null) {
            runner.stop();
            runner = null;
        }
    }

    public boolean mouseDown(Event evt, int xx, int yy) {
        if (Link[current] != null) {
            runner.stop();
            AppletContext browser = getAppletContext();
            if (target$ != null) {
                browser.showDocument(Link[current], target$);
            } else {
                browser.showDocument(Link[current]);
            }
        }
        return true;
    }
}
